//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#pragma link "C:\\BCB\\CBuilder5\\LIB\\Psdk\\psapi.lib"

#include "MemoryStatusUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

extern int iGetMemCount, iFreeMemCount, iReallocMemCount;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  ThisProcess=GetCurrentProcess();
  TotalAllocate=0;

  DGrid->Cells[0][0]="TotalAddrSpace";
  DGrid->Cells[0][1]="TotalUncommitted";
  DGrid->Cells[0][2]="TotalCommitted";
  DGrid->Cells[0][3]="TotalAllocated";
  DGrid->Cells[0][4]="TotalFree";
  DGrid->Cells[0][5]="FreeSmall";
  DGrid->Cells[0][6]="FreeBig";
  DGrid->Cells[0][7]="Unused";
  DGrid->Cells[0][8]="Overhead";
  DGrid->Cells[0][9]="HeapErrorCode";

  DGrid->Cells[0][10]="MemoryLoad";
  DGrid->Cells[0][11]="TotalPhys";
  DGrid->Cells[0][12]="AvailPhys";
  DGrid->Cells[0][13]="TotalPageFile";
  DGrid->Cells[0][14]="AvailPageFile";
  DGrid->Cells[0][15]="TotalVirtual";
  DGrid->Cells[0][16]="AvailVirtual";

//  DGrid->Cells[0][17]="AllocateCount";
//  DGrid->Cells[0][18]="FreeCount";
//  DGrid->Cells[0][19]="ReAllocCount";

  DGrid->Cells[0][17]="PageFaultCount";
  DGrid->Cells[0][18]="PeakWorkingSetSize";
  DGrid->Cells[0][19]="WorkingSetSize";
  DGrid->Cells[0][20]="QuotaPeakPagedPoolUsage";
  DGrid->Cells[0][21]="QuotaPagedPoolUsage";
  DGrid->Cells[0][22]="QuotaPeakNonPagedPoolUsage";
  DGrid->Cells[0][23]="QuotaNonPagedPoolUsage";
  DGrid->Cells[0][24]="PagefileUsage";
  DGrid->Cells[0][25]="PeakPagefileUsage";

  DGrid->Cells[0][26]="GDI objects";
  DGrid->Cells[0][27]="USER objects";
  DGrid->Cells[0][28]="Handle Count";

  DGrid->Cells[0][29]="ReadOperationCount";
  DGrid->Cells[0][30]="WriteOperationCount";
  DGrid->Cells[0][31]="OtherOperationCount";
  DGrid->Cells[0][32]="ReadTransferCount";
  DGrid->Cells[0][33]="WriteTransferCount";
  DGrid->Cells[0][34]="OtherTransferCount";

  DGrid->ColWidths[0]=220;
  DGrid->ColWidths[1]=100;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  THeapStatus HeapStatus=GetHeapStatus();

  DGrid->Cells[1][0]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.TotalAddrSpace)));
  DGrid->Cells[1][1]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.TotalUncommitted)));
  DGrid->Cells[1][2]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.TotalCommitted)));
  DGrid->Cells[1][3]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.TotalAllocated)));
  DGrid->Cells[1][4]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.TotalFree)));
  DGrid->Cells[1][5]=Format("%.0n", ARRAYOFCONST(((double)System::AllocMemCount)));
  DGrid->Cells[1][6]=Format("%.0n", ARRAYOFCONST(((double)System::AllocMemSize)));
  DGrid->Cells[1][7]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.Unused)));
  DGrid->Cells[1][8]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.Overhead)));
  DGrid->Cells[1][9]=Format("%.0n", ARRAYOFCONST(((double)HeapStatus.HeapErrorCode)));

  TMemoryStatus MemoryStatus;
  GlobalMemoryStatus(&MemoryStatus);

  DGrid->Cells[1][10]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwMemoryLoad)));
  DGrid->Cells[1][11]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwTotalPhys)));
  DGrid->Cells[1][12]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwAvailPhys)));
  DGrid->Cells[1][13]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwTotalPageFile)));
  DGrid->Cells[1][14]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwAvailPageFile)));
  DGrid->Cells[1][15]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwTotalVirtual)));
  DGrid->Cells[1][16]=Format("%.0n", ARRAYOFCONST(((double)MemoryStatus.dwAvailVirtual)));

//  DGrid->Cells[1][17]=Format("%.0n", ARRAYOFCONST(((double)iGetMemCount)));
//  DGrid->Cells[1][18]=Format("%.0n", ARRAYOFCONST(((double)iFreeMemCount)));
//  DGrid->Cells[1][19]=Format("%.0n", ARRAYOFCONST(((double)iReallocMemCount)));

  PROCESS_MEMORY_COUNTERS memCounters;

  if(GetProcessMemoryInfo(ThisProcess,&memCounters,sizeof(PROCESS_MEMORY_COUNTERS)))
  {
    DGrid->Cells[1][17]=Format("%.0n", ARRAYOFCONST(((double)memCounters.PageFaultCount)));
    DGrid->Cells[1][18]=Format("%.0n", ARRAYOFCONST(((double)memCounters.PeakWorkingSetSize)));
    DGrid->Cells[1][19]=Format("%.0n", ARRAYOFCONST(((double)memCounters.WorkingSetSize)));
    DGrid->Cells[1][20]=Format("%.0n", ARRAYOFCONST(((double)memCounters.QuotaPeakPagedPoolUsage)));
    DGrid->Cells[1][21]=Format("%.0n", ARRAYOFCONST(((double)memCounters.QuotaPagedPoolUsage)));
    DGrid->Cells[1][22]=Format("%.0n", ARRAYOFCONST(((double)memCounters.QuotaPeakNonPagedPoolUsage)));
    DGrid->Cells[1][23]=Format("%.0n", ARRAYOFCONST(((double)memCounters.QuotaNonPagedPoolUsage)));
    DGrid->Cells[1][24]=Format("%.0n", ARRAYOFCONST(((double)memCounters.PagefileUsage)));
    DGrid->Cells[1][25]=Format("%.0n", ARRAYOFCONST(((double)memCounters.PeakPagefileUsage)));
  }

    DGrid->Cells[1][26]=Format("%.0n", ARRAYOFCONST(((double)GetGuiResources(ThisProcess,GR_GDIOBJECTS))));
    DGrid->Cells[1][27]=Format("%.0n", ARRAYOFCONST(((double)GetGuiResources(ThisProcess,GR_USEROBJECTS))));

  // DWORD dwHandleCount;
  // if(GetProcessHandleCount(ThisProcess,&dwHandleCount))
  //   DGrid->Cells[1][28]=Format("%.0n", ARRAYOFCONST(((double)dwHandleCount)));

  IO_COUNTERS IoCounters;
  if(GetProcessIoCounters(ThisProcess,&IoCounters))
  {
    DGrid->Cells[1][29]=Format("%.0n", ARRAYOFCONST(((double)IoCounters.ReadOperationCount)));
    DGrid->Cells[1][30]=Format("%.0n", ARRAYOFCONST(((double)IoCounters.WriteOperationCount)));
    DGrid->Cells[1][31]=Format("%.0n", ARRAYOFCONST(((double)IoCounters.OtherOperationCount)));
    DGrid->Cells[1][32]=Format("%.0n", ARRAYOFCONST(((double)IoCounters.ReadTransferCount)));
    DGrid->Cells[1][33]=Format("%.0n", ARRAYOFCONST(((double)IoCounters.WriteTransferCount)));
    DGrid->Cells[1][34]=Format("%.0n", ARRAYOFCONST(((double)IoCounters.OtherTransferCount)));
  }

  Label1->Caption=List->Items->Count;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnAllocateMemClick(TObject *Sender)
{
  int SizeMax=Edit1->Text.ToIntDef(1024);
  Edit1->Text=SizeMax;
  int Size=SizeMax;
    char *Buf=new char[Size];
    TotalAllocate+=Size;
    List->Items->AddObject(String(Size)+",*"+IntToHex(int(Buf),8),(TObject *)Buf);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnFreeMemoryClick(TObject *Sender)
{
  if(List->ItemIndex>=0
  && List->ItemIndex<List->Items->Count)
  {
    char *Buf=(char *)List->Items->Objects[List->ItemIndex];
    int Size=List->Items->Strings[List->ItemIndex].SubString(1,
             List->Items->Strings[List->ItemIndex].AnsiPos(",")-1).ToIntDef(0);
    TotalAllocate-=Size;
    List->Items->Delete(List->ItemIndex);
    delete [] Buf;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnFreeAllMemoryClick(TObject *Sender)
{
  while(List->Items->Count>0)
  {
    char *Buf=(char *)List->Items->Objects[0];
    int Size=List->Items->Strings[0].SubString(1,
             List->Items->Strings[0].AnsiPos(",")-1).ToIntDef(0);
    TotalAllocate-=Size;
    List->Items->Delete(0);
    delete [] Buf;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BtnAllocateAndUseClick(TObject *Sender)
{
  int Size=Edit1->Text.ToIntDef(1024);
  Edit1->Text=Size;
  char *Buf=new char[Size];
  TotalAllocate+=Size;
  for(int i=0;i<Size;i+=4096)   // Use IT!!
    Buf[i]=0;
  List->Items->AddObject(String(Size)+",*"+IntToHex(int(Buf),8),(TObject *)Buf);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DGridDrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
{
  if(State.Contains(gdFixed))return;
  DGrid->Canvas->TextRect(Rect, // ,Rect.Left,Rect.Top,DGrid->Cells[ACol][ARow]);
    Rect.Left+Rect.Width()-DGrid->Canvas->TextWidth(DGrid->Cells[ACol][ARow]),
    Rect.Top+(Rect.Height()-DGrid->Canvas->TextHeight(DGrid->Cells[ACol][ARow]))/2,
    DGrid->Cells[ACol][ARow]);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnUseAgainClick(TObject *Sender)
{
  if(List->ItemIndex>=0
  && List->ItemIndex<List->Items->Count)
  {
    char *Buf=(char *)List->Items->Objects[List->ItemIndex];
    int Size=List->Items->Strings[List->ItemIndex].SubString(1,
             List->Items->Strings[List->ItemIndex].AnsiPos(",")-1).ToIntDef(0);
    for(int i=0;i<Size;i+=4096) // Use Again
      Buf[i]=0;
    List->Items->Strings[List->ItemIndex]=String(Size)+",*"+IntToHex(int(Buf),8);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnEXITClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BtnRandomFree10Click(TObject *Sender)
{
  int iCount=10;
  if(List->Items->Count<10)
    iCount=List->Items->Count;
    int Index;
    for(int i=0;i<iCount;i++)
    {
      Index=random(List->Items->Count);
      char *Buf=(char *)List->Items->Objects[Index];
      int Size=List->Items->Strings[Index].SubString(1,
               List->Items->Strings[Index].AnsiPos(",")-1).ToIntDef(0);
      TotalAllocate-=Size;
      List->Items->Delete(Index);
      delete [] Buf;
    }
/*
  for(int i=0;i<List->Items->Count;i++)
  {
    int Pos=List->Items->Strings[i].AnsiPos("*");
    if(Pos>0)
      List->Items->Strings[i]=List->Items->Strings[i].SubString(1,Pos-1)
        +IntToHex(int(List->Items->Objects[i]),8);
  }
*/
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BtnMinToFreeMemClick(TObject *Sender)
{
  static int iCount=0;
  if(SetProcessWorkingSetSize(ThisProcess,(SIZE_T)-1,(SIZE_T)-1))
  {
    iCount++;
    // BtnMinToFreeMem->Caption="Like Min..."+String(iCount);
    // Sleep(100) ;
    // BtnClearUseStatusClick(Sender);
    for(int i=0;i<List->Items->Count;i++)
    {
      int Pos=List->Items->Strings[i].AnsiPos("*");
      if(Pos>0)
        List->Items->Strings[i]=List->Items->Strings[i].SubString(1,Pos-1)
          +IntToHex(int(List->Items->Objects[i]),8);
    }
  }
}
//---------------------------------------------------------------------------
/*
Allocate Memory: new @O -> eεO, TotalAddrSpace,TotalAllocated W[

Allocate&Use: new @Oõ -> eιεO, TotalAddrSpace,TotalAllocated W[

Use Again: wOA@ -> pGeSeιO, hU|eιO

Clear Use Status:wȪO|*AsuOMP

Free Memory: delete wO -> eΪOAO餣@w|A
iHݨ TotalAllocated ֡A TotalAddrSpace @w|֡A TotalAddrSpace 
ɡAeΪON|C

Free ALL: zUC@ Item  Free MemoryA̫ᵲGiP̪쪬AP

Like Min...: O̤pƦA٭쪺pAO龨iೣFCɦpGC٦FA
iHU Use Again iHݨ{SeιOFCӦL{AeεO骺jpOܪC
*/


void __fastcall TForm1::BtnRandomAllocate10Click(TObject *Sender)
{
  int SizeMax=Edit1->Text.ToIntDef(1024);
  Edit1->Text=SizeMax;
  int Size;

  for(int i=0;i<10;i++)
  {
    Size=random(SizeMax)+100;
    char *Buf=new char[Size];
    TotalAllocate+=Size;
    for(int i=0;i<Size;i+=4096)   // Use IT!!
      Buf[i]=0;
    List->Items->AddObject(String(Size)+",*"+IntToHex(int(Buf),8),(TObject *)Buf);
  }
}
//---------------------------------------------------------------------------

